--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/nap.S	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/nap.S	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,534 @@
+    .global naptime
+    .global INSN_END
+
+    /* For debugging purposes. Normally, we enable everything. */
+    .set    DO_AUDIO, 0
+    .set    DO_DDR3, 0
+    .set    DO_FPC, 0
+    .set    DO_GPIO, 1
+    .set    DO_UART, 0
+    .set    DO_USB_EHCI, 0
+    .set    DO_USB_OHCI, 0
+    .set    DO_VIDEO, 0
+    .set    DO_WDT, 0
+    .set    DO_CPUTIMER, 0
+
+    .set    GPIO_PB_BITNO, 8        /* Wake-up push button is GPIO bit #8. */
+    .set    GPIO_A_DATA, 32         /* Offset of the GPIO port A data register. */
+    .set    GPIO_A_INTR_EN, 40      /*    ...and the GPIO interrupt enable register */
+    .set    GPIO_A_INTR_POL, 44     /*    ...and the GPIO interrupt polarity register */
+    .set    GPIO_A_DDR, 36          /*    ... and the data direction register. */
+
+    .set    TIMER_INTR_EN, 20       /* Offset of the AHB timer 0 interrupt enable register. */
+    .set    TIMER_INTR_ENABLE_MASK, 1       /* Mask to enable/disable timer interrupt in INTR_EN. */
+    .set    TIMER_INTR_CLR, 24      /*     ...and the interrupt clear register. */
+    .set    TIMER_ENR, 28           /*     ...and the timer enable register. */
+    .set    TIMER_ENABLE_DISABLE_MASK, 1    /* Mask to enable/disable timer in ENR. */
+    .set    TIMER_INTR_STA, 40      /*     ...and the timer interrupt status register. */
+
+    .set    UART_LCR, 12            /* 16550A/8250 console UART line control register offset. */
+    .set    UART_LCR_DL, 7          /* LCR divisor latch enable bit */
+    .set    UART_IER, 4             /*    ...and the interrupt enable register */
+    .set    UART_FCR, 8             /*    ...and the FIFO control register (write only!) */
+
+    .set    DDR_LP_CTRL, 0x40           /* Offset of the DDR low power control register. */
+    .set    SELF_REFRESH_SW_CTRL, 1     /* Bit mask of auto self-refresh SW control enable. */
+    .set    SELF_REFRESH_ENTER, 2       /* Bit mask of the DDR auto self-refresh enter bit. */
+    .set    SELF_REFRESH_EXIT, 4        /* Bit mask of the DDR auto self-refresh exit bit. */
+    .set    SELF_REFRESH_ACK_CLEAR, 8   /* Bit mask of the auto self-refresh ACK clear bit. */
+    .set    SELF_REFRESH_ACK, 16        /* Bit mask of the auto self-refresh entry/exit ACK bit. */
+
+    /* This one is a mask, not a shift. */
+    .set    ID_SCS_CKEN_DDR_MASK, 0x2
+
+    .set    CPSR_FIQ_MASK, 0x40     /* Bit mask for the FIQ bit in the ARM CPSR */
+    .set    CPSR_IRQ_MASK, 0x80     /*    ...and for the IRQ bit */
+
+    .set    WDT_DISABLE, 0x34       /* Offset of the watchdog disable register (write only). */
+    .set    WDT_CONTROL, 0x28       /* Offset of the watchdog (IRQ 30) control register. */
+    .set    WDT_CTRL_ENABLE, 1      /* Bit 0 is the enable/disable bit of the WD control reg. */
+    .set    CPU_TIMER_CONTROL, 8    /* Offset of CPU timer (IRQ 29) control register */
+    .set    CPU_TIMER_INTEN, 5      /* Bits in the timer control that enable interrupts. */
+    .set    CPU_TIMER_INTST, 0x0c   /* Offset of the CPU timer interrupt status register. */
+    .set    WDT_INTR_STAT, 0x2c     /* Offset of the Watchdog timer interrupt status register. */
+    
+    .set    FPC_INTM, 4             /* Offset of front panel control interrupt mask register. */
+
+    .set    USBSTS, 4               /* Offset of USB EHCI status register */
+    .set    USBINTR, 8              /* Offset of USB EHCI interrupt enable register */
+
+    .set    OHCI_INTRSTAT, 12       /* USB OHCI interrupt status register. */
+    .set    OHCI_INTRENAB, 16       /* USB OHCI interrupt enable register. */
+    .set    OHCI_INTRDISAB, 20      /* USB OHCI interrupt disable register. */
+    .set    OHCI_MIE_SHIFT, 31      /* Master interrupt bit in the OHCI interrupt enable/disable register. */
+
+    .set    COPSW_INTEN, 192         /* Video interrupt enable offset */
+
+    .set    AUD_INTMASK, 0x208          /* Offset of DSP_INT_MASK. */
+    .set    AUD_INTMASK_BITS, 31        /* Bits 0-4 of DSP_INT_MASK are maskable. */
+
+    .set    GPIO_INTSAVE, 4         /* Offset in the stack frame holding the old GPIO interrupt mask. */
+    .set    FPC_INTSAVE, 8          /* Offset in the stack frame holding the old front panel control interrupt mask. */
+    .set    EHCI_INTSAVE, 12        /* Offset in the stack frame holding the old USB EHCI interrupt mask. */
+    .set    VIDEO_INTSAVE, 16       /* Offset in the stack frame holding the old video interrupt mask. */
+    .set    AUDIO_INTSAVE, 20       /* Offset in the stack frame holding the old audio interrupt mask. */
+
+
+    .set    PARAM1_SAVE, 24
+    .set    PARAM2_SAVE, 28
+
+/* ARM register equivalents, designed to make the code more readable. */
+
+timerbase   .req    r0
+idscsclken  .req    r1
+uartbase    .req    r6
+
+naptime:
+
+    /* So we're here in the line buffer now. Interrupts are disabled globally,
+       but not from the peripherals. We need to do the latter so that no
+       interrupts will happen that wake us up (except for the push button)
+       The 1176JZF-S TRM states that even if an interrupt occurs that is masked,
+       the CPU still will wake up from the WFI state. Therefore, we must still
+       disable interrupts at the source.
+
+       At this point, the MMU is on, but we are running out of the
+       line buffer. I don't want to turn off the MMU because I don't
+       see any benefit to doing that, and I would need to map the line
+       buffer to a virtual address of 0xb1000000 prior to jumping to
+       the line buffer and turning it off. Otherwise, once I've disabled it,
+       pc will hold an invalid address. */
+
+    /* Set up stack frame */
+    stmfd   sp!, {fp, lr}
+    add     fp, sp, #4
+    sub     sp, sp, #64
+
+    ldr     uartbase, UART_BASE_VA
+
+    /* Disable all interrupts (both IRQ and FIQ) */
+    dsb
+    mrs    r4, cpsr
+    orr    r4, r4, #(CPSR_IRQ_MASK|CPSR_FIQ_MASK)
+    msr    cpsr, r4
+
+    /* Pre-load a shiftable 1-bit. */
+    mov     r8, #1
+
+    /* R0 contains the irq mask list length, R1 points to the list. They are
+       uint32_t and uint32_t *, respectively. R2 is the GPIO wakeup list. */
+
+    str     r0, [sp, #PARAM1_SAVE]  /* save list length */
+    str     r1, [sp, #PARAM2_SAVE]  /* save list address. */
+    cmp     r0, #0          /* See how many masks remain. */
+    beq     maskdone1
+nextmask1:
+    ldr     r7, GIC_DIST_CLREN_VA
+    ldr     r4, [r1]        /* r4 := the next IRQ #. */
+    mov     r4, r4, lsr #5  /* r4 := word offset from base in GIC */
+    mov     r4, r4, lsl #2  /* r4 := byte offset from base in GIC (of start of word) */
+    add     r7, r7, r4      /* r7 := the address of the clear enable reg in the GIC */
+    ldr     r4, [r1], #4    /* r4 := the next IRQ #, increment to next address */
+    and     r4, r4, #31     /* bit # is now in r4. */
+    mov     r5, r8, lsl r4  /* shift a 1 bit r4 to the left */
+    str     r5, [r7]        /* change that bit in the GIC clear enable register. */
+    dmb                     /* make sure mem op completes before doing next. */
+    subs    r0, r0, #1
+    bne     nextmask1
+maskdone1:
+
+    ldr     idscsclken, ID_SCS_CLKEN_VA
+    ldr     timerbase, WDT_BASE_VA
+
+    .if     DO_WDT != 0
+    /* Rather than switch the watchdog back to timer mode, simply stop it from counting. */
+    ldr     r4, [timerbase, #WDT_CONTROL]
+    bic     r4, r4, #WDT_CTRL_ENABLE
+    str     r4, [timerbase, #WDT_CONTROL]
+    dmb
+    .endif
+
+    .if     DO_CPUTIMER != 0
+    ldr     r4, [timerbase, #CPU_TIMER_CONTROL]
+    bic     r4, r4, #CPU_TIMER_INTEN
+    str     r4, [timerbase, #CPU_TIMER_CONTROL]
+    dmb
+    ldr     r4, [timerbase, #CPU_TIMER_INTST]
+    bic     r4, r4, #1                          /* Clear out any pending timer interrupt. */
+    str     r4, [timerbase, #CPU_TIMER_INTST]
+    dmb
+    .endif
+
+    .if     DO_GPIO != 0
+    ldr     r5, GPIO_BASE_VA
+    ldr     r4, [r5, #GPIO_A_INTR_EN]       /* Save old GPIO interrupt mask */
+    str     r4, [sp, #GPIO_INTSAVE]
+    str     r2, [r5, #GPIO_A_INTR_EN]       /* Store the one from /sys/power/gpio_wakeup */
+    .endif
+
+    .if     DO_FPC != 0
+    /* Disable front panel control interrupts. */
+    ldr     r5, FPC_BASE_VA
+    ldr     r4, [r5, #FPC_INTM]
+    str     r4, [sp, #FPC_INTSAVE]                    /* Save old mask. */
+    dmb
+    mov     r4, #0
+    str     r4, [r5, #FPC_INTM]
+    dmb
+    .endif
+
+    .if     DO_UART != 0
+    /* Turn off serial port interrupts on UART 0 */
+    ldr     r4, [uartbase, #UART_LCR]
+    bic     r4, r4, r8, lsl #UART_LCR_DL  /* Set LCR bit 7 to 0 */
+    str     r4, [uartbase, #UART_LCR]
+    dmb
+
+    ldr     r4, [uartbase, #UART_IER]
+    and     r9, r4, #0xf        /* save bits in r9 for restore */
+    bic     r4, r4, #0xf        /* disable interrupts of interest. */
+    str     r4, [uartbase, #UART_IER]
+    dmb
+    .endif
+
+    .if     DO_USB_EHCI != 0
+    /* Now disable USB EHCI interrupts. */
+    ldr     r7, USB_EHCI_VA
+    ldr     r4, [r7, #USBSTS]   /* Read USB status in prep for intr clear. */
+    and     r4, r4, #63         /* Mask all but possible interrupt sources. */
+    str     r4, [r7, #USBSTS]   /* Clear the condition by writing a 1 bit. */
+    dmb
+
+    ldr     r4, [r7, #USBINTR]  /* Read interrupt mask register. */
+    and     r5, r4, #63         /* Set reserved bits to 0. */
+    str     r5, [sp, #EHCI_INTSAVE]       /* Save old interrupt enable bits. */
+    dmb
+    eor     r4, r4, r4          /* Clear all bits and disable interrupts. */
+    str     r4, [r7, #USBINTR]
+    dmb
+    .endif
+
+    .if     DO_USB_OHCI != 0
+    /* Disable USB OHCI interrupts. These come from 1.0a of the OHCI spec. */
+    ldr     r7, USB_OHCI_VA
+    mov     r4, r8, lsl #OHCI_MIE_SHIFT /* Disable interrupts via master intr bit. */
+    str     r4, [r7, #OHCI_INTRDISAB]
+    dmb
+
+    ldr     r4, [r7, #OHCI_INTRSTAT]   /* Read USB status in prep for intr clear. */
+    ldr     r5, OHCI_STAT_CLEAR
+    bic     r4, r4, r5          /* Mask all but possible interrupt sources. */
+    str     r4, [r7, #USBSTS]   /* Clear the condition by writing a 1 bit. */
+    dmb
+    .endif
+
+    .if     DO_VIDEO != 0
+    /* Disable video interrupt. */
+    ldr     r7, VIDEO_INTR_REGS_VA
+    ldr     r4, [r7, #COPSW_INTEN]      /* Save old interrupt enable bit. */
+    and     r4, r4, r8
+    str     r4, [sp, #VIDEO_INTSAVE]
+    dmb
+    bic     r4, r4, r8
+    str     r4, [r7, #COPSW_INTEN]
+    dmb
+    .endif
+
+    .if     DO_AUDIO != 0
+    /* Disable audio interrupt. */
+    ldr     r7, AUDIO_INTR_REGS_VA
+    ldr     r4, [r7, #AUD_INTMASK]
+    and     r4, r4, #AUD_INTMASK_BITS
+    str     r4, [sp, #AUDIO_INTSAVE]    /* Save old interrupt enable bits. */
+    dmb
+    bic     r4, r4, #AUD_INTMASK_BITS
+    str     r4, [r7, #AUD_INTMASK]
+    dmb
+    .endif
+
+    .if     DO_DDR3 != 0
+    dsb
+/*
+        Desired register access sequence:
+
+        LP_CTRL[1] := 1 to request entry into auto self-refresh.
+        Wait for ack (LP_CTRL[4] == 1)
+        LP_CTRL[3] := 1 to clear ack bit.
+
+        Now in auto self-refresh mode.
+        Turn off DDR clock.
+        Enter WFI state
+
+        LP_CTRL[2] := 1 to request exit from auto self-refresh
+        Wait for ack (LP_CTRL[4] == 1)
+        LP_CTRL[3] := 1 to clear ack bit.
+
+        Truth table (from Samsung DDR3 Device Operations Rev1.21_Sep.10)
+        X = don't care, v = valid
+                        CKE
+                        prev curr  CS*  RAS* CAS* WE* BA
+        SRE             1    0     0    0    0    1   v   cmd 1
+        SRX             0    1     0    1    1    1   v   cmd 7
+                            also   1    v    v    v   X   cmd 8-f
+*/
+    /* Move DDR base address into R7. */
+    ldr     r7, DDR_BASE_VA
+
+    /* Request entry into self-refresh. */
+    mov     r4, #SELF_REFRESH_ENTER
+    str     r4, [r7, #DDR_LP_CTRL]
+    dmb
+
+    /* Wait for ACK. */
+notrdy1:
+    ldr     r4, [r7, #DDR_LP_CTRL]
+    ands    r4, r4, #SELF_REFRESH_ACK
+    beq     notrdy1
+
+    /* Clear ACK. */
+    mov     r4, #SELF_REFRESH_ACK_CLEAR
+    str     r4, [r7, #DDR_LP_CTRL]
+    dsb
+
+    /* Allow time for any remaining DDR access to finish. */
+    mov     r1, r8, lsl #17
+xxx:
+    subs    r1, r1, #1
+    bne     xxx
+
+    /* Turn off DDR clock. */
+    isb
+    ldr     r1, ID_SCS_CLKEN_VA
+    ldr     r4, [r1]
+    bic     r4, #1
+    str     r4, [r1]
+    dsb
+
+    .endif
+
+    /* Wait for interrupt */
+    mov     r4, #0
+    wfi
+    /* Used to be mcr     p15,0,r4,c7,c0,4 */
+
+    .if     DO_DDR3 != 0
+
+    /* Turn on DDR clock. */
+    ldr     r4, [r1]
+    orr     r4, #1
+    str     r4, [r1]
+    dsb
+    isb
+
+    /* Might not be necessary. Wait a bit. */
+    mov     r1, r8, lsl #17
+xxx2:
+    subs    r1, r1, #1
+    bne     xxx2
+
+    /* Request exit from self refresh. */
+    mov     r4, #SELF_REFRESH_EXIT
+    str     r4, [r7, #DDR_LP_CTRL]
+    dmb
+
+    /* Wait for ACK. */
+notrdy2:
+    ldr     r4, [r7, #DDR_LP_CTRL]
+    ands    r4, r4, #SELF_REFRESH_ACK
+    beq     notrdy2
+
+    /* Clear ACK. */
+    mov     r4, #SELF_REFRESH_ACK_CLEAR
+    str     r4, [r7, #DDR_LP_CTRL]
+    dsb
+
+    .endif
+
+    .if     DO_AUDIO != 0
+    /* Re-enable audio interrupt. */
+    ldr     r5, [sp, #AUDIO_INTSAVE]    /* Load old interrupt enable bits. */
+    ldr     r7, AUDIO_INTR_REGS_VA
+    ldr     r4, [r7, #AUD_INTMASK]
+    orr     r4, r4, r5
+    str     r4,  [r7, #AUD_INTMASK]
+    dmb
+    .endif
+
+    .if     DO_VIDEO != 0
+    /* Re-enable video interrupt. */
+    ldr     r4, [sp, #VIDEO_INTSAVE]    /* Load old interrupt enable bit. */
+    ldr     r7, VIDEO_INTR_REGS_VA
+    ldr     r5, [r7, #COPSW_INTEN]
+    orr     r5, r4, r5
+    str     r5, [r7, #COPSW_INTEN]
+    dmb
+    .endif
+
+    .if     DO_USB_OHCI != 0
+    /* Re-enable OHCI interrupt by setting MIE. */
+    mov     r4, r8, lsl #OHCI_MIE_SHIFT
+    ldr     r7, USB_OHCI_VA
+    str     r4, [r7, #OHCI_INTRENAB]
+    dmb
+    .endif
+
+    .if     DO_USB_EHCI != 0
+    /* Re-enable EHCI interrupt. */
+    ldr     r4, [sp, #EHCI_INTSAVE]
+    ldr     r7, USB_EHCI_VA
+    str     r4, [r7, #USBINTR]
+    dmb
+    .endif
+
+    .if     DO_UART != 0
+    /* Re-enable serial port interrupts on UART 0 */
+    ldr     r4, [uartbase, #UART_LCR]
+    bic     r4, r4, r8, lsl #UART_LCR_DL          /* Set LCR bit 7 to 0 */
+    str     r4, [uartbase, #UART_LCR]
+    dmb
+
+    ldr     r4, [uartbase, #UART_IER]
+    orr     r4, r4, r9                  /* Restore saved bits from r9. */
+    str     r4, [uartbase, #UART_IER]   /* Restore IER */
+    dmb
+    .endif
+
+    .if     DO_FPC != 0
+    /* Re-enable front panel control interrupts. */
+    ldr     r4, [sp, #FPC_INTSAVE]      /* Load old interrupt enable bits. */
+    ldr     r7, FPC_BASE_VA
+    str     r4, [r7, #FPC_INTM]
+    dmb
+    .endif
+
+    .if     DO_GPIO != 0
+    ldr     r5, GPIO_BASE_VA
+    ldr     r4, [sp, #GPIO_INTSAVE]         /* Restore old GPIO interrupt mask */
+    str     r4, [r5, #GPIO_A_INTR_EN]
+    .endif
+
+    .if     DO_CPUTIMER != 0
+    ldr     r4, [timerbase, #CPU_TIMER_CONTROL]
+    orr     r4, r4, #CPU_TIMER_INTEN
+    str     r4, [timerbase, #CPU_TIMER_CONTROL]
+    dmb
+    .endif
+
+    .if     DO_WDT != 0
+    /* Re-start the watchdog timer. I'm assuming that the prescale and load
+       values have been preserved since they haven't been touched. */
+    ldr     r4, [timerbase, #WDT_CONTROL]
+    orr     r4, r4, #WDT_CTRL_ENABLE
+    str     r4, [timerbase, #WDT_CONTROL]
+    dmb
+    .endif
+
+    ldr     r0, [sp, #PARAM1_SAVE]  /* recall list length */
+    ldr     r1, [sp, #PARAM2_SAVE]  /* recall list address. */
+    cmp     r0, #0          /* See how many masks remain. */
+    beq     maskdone2
+nextmask2:
+    ldr     r7, GIC_DIST_SETEN_VA
+    ldr     r4, [r1]        /* r4 := the next IRQ #. */
+    mov     r4, r4, lsr #5  /* r4 := word offset from base in GIC */
+    mov     r4, r4, lsl #2  /* r4 := byte offset from base in GIC (of start of word) */
+    add     r7, r7, r4      /* r7 := the address of the clear enable reg in the GIC */
+    ldr     r4, [r1], #4    /* r4 := the next IRQ #, increment to next address */
+    and     r4, r4, #31     /* bit # is now in r4. */
+    mov     r5, r8, lsl r4  /* shift a 1 bit r4 to the left */
+    str     r5, [r7]        /* change that bit in the GIC clear enable register. */
+    dmb                     /* make sure mem op completes before doing next. */
+    subs    r0, r0, #1
+    bne     nextmask2
+maskdone2:
+
+    /* Re-enable interrupts globally. */
+    mrs    r4, cpsr
+    bic    r4, r4, #(CPSR_IRQ_MASK|CPSR_FIQ_MASK)
+    msr    cpsr, r4
+
+    mov     r0, #0
+    sub     sp, fp, #4
+    ldmfd   sp!, {fp, pc} 
+
+
+
+
+
+
+/* These are the CNC1900 definitions. */
+
+GIC_DIST_SETEN_VA:
+    .word   0xf8021100
+
+GIC_DIST_CLREN_VA:
+    .word   0xf8021180
+
+/* Watchdog timer. */
+WDT_BASE_VA:
+    .word   0xf8020600
+
+GIC_BASE_VA:
+    .word   0xf8021d00
+
+/* Front panel control virtual address. */
+FPC_BASE_VA:
+    .word   0xf8172000
+
+/* Virtual address of GPIO port A registers. */
+GPIO_BASE_VA:
+    .word   0xf8260000
+
+/* Virtual address of the console UART. */
+UART_BASE_VA:
+    .word   0xf81f1000
+
+/* USB EHCI virtual address */
+USB_EHCI_VA:
+    .word   0xf8200000
+
+/* USB OHCI virtual address */
+USB_OHCI_VA:
+    .word   0xf8210000
+
+/* Use the COPSWA */
+VIDEO_INTR_REGS_VA:
+    .word   0xfcd10000
+
+IO_REGS_BASE_VA:
+    .word   0xf8100000
+
+IO_MEDIA_PROCESSOR_BASE_VA:
+    .word   0xfc100000
+
+/* Virtual address of the clock enable register of ID_SCS. */
+ID_SCS_CLKEN_VA:
+    .word   0xfd300140
+
+IO_LINE_BUFFER_BASE_VA:
+    .word   0xf8000000
+
+AUDIO_INTR_REGS_VA:
+    .word   0xfc300000
+
+/* Base address of the DDR control registers. */
+DDR_BASE_VA:
+    .word   0xf8110000
+/* End CNC1900 definitions */
+
+
+
+
+
+/* These two values must be written in order to the watchdog timer
+   disable register in order to disable it. */
+WD_DISABLE_VALUE1:
+    .word   0x12345678
+WD_DISABLE_VALUE2:
+    .word   0x87654321
+
+OHCI_STAT_CLEAR:
+    .word   0x4000007f
+
+INSN_END:
+    nop
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/pinmux.c linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/pinmux.c
